package net.mcreator.nightmarish_kingdom;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.init.Blocks;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIOpenDoor;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAIMoveIndoors;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.EntityCreature;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.model.ModelBase;

@Elementsnightmarish_kingdom.ModElement.Tag
public class MCreatorAngelDemon extends Elementsnightmarish_kingdom.ModElement {
	public static final int ENTITYID = 22;
	public static final int ENTITYID_RANGED = 23;

	public MCreatorAngelDemon(Elementsnightmarish_kingdom instance) {
		super(instance, 195);
	}

	@Override
	public void initElements() {
		elements.entities.add(() -> EntityEntryBuilder.create().entity(EntityCustom.class)
				.id(new ResourceLocation("nightmarish_kingdom", "angel_golem"), ENTITYID).name("angel_golem").tracker(64, 1, true).build());
	}

	@Override
	public void init(FMLInitializationEvent event) {
		Biome[] spawnBiomes = {Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:nightmarishkingdombiome")),
				Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:mesadesert")),
				Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:moutains")),};
		EntityRegistry.addSpawn(EntityCustom.class, 20, 1, 1, EnumCreatureType.CREATURE, spawnBiomes);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void preInit(FMLPreInitializationEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(EntityCustom.class, renderManager -> {
			return new RenderLiving(renderManager, new ModelGolem(), 0.7999999999999999f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("nightmarish_kingdom:textures/angel_golem.png");
				}
			};
		});
	}

	public static class EntityCustom extends EntityCreature {
		public EntityCustom(World world) {
			super(world);
			setSize(1.4f, 2.7f);
			experienceValue = 0;
			this.isImmuneToFire = false;
			setNoAI(!true);
			this.targetTasks.addTask(1, new EntityAINearestAttackableTarget(this, MCreatorMorzaron.EntityCustom.class, true, true));
			this.tasks.addTask(2, new EntityAIOpenDoor(this, true));
			this.tasks.addTask(3, new EntityAIMoveIndoors(this));
			this.tasks.addTask(4, new EntityAIOpenDoor(this, false));
			this.tasks.addTask(5, new EntityAIWander(this, 1));
			this.tasks.addTask(6, new EntityAILookIdle(this));
			this.tasks.addTask(7, new EntityAISwimming(this));
			this.tasks.addTask(8, new EntityAILeapAtTarget(this, (float) 0.8));
		}

		@Override
		public EnumCreatureAttribute getCreatureAttribute() {
			return EnumCreatureAttribute.UNDEFINED;
		}

		@Override
		protected Item getDropItem() {
			return new ItemStack(Blocks.QUARTZ_BLOCK, (int) (1), 0).getItem();
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(""));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation("entity.irongolem.hurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation("entity.irongolem.death"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			if (this.getEntityAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.2D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(500D);
			if (this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(12D);
		}

		protected void dropRareDrop(int par1) {
			this.dropItem(new ItemStack(Blocks.DOUBLE_PLANT, (int) (1)).getItem(), 1);
		}
	}

	/**
	 * ModelIronGolem - Either Mojang or a mod author Created using Tabula 7.0.0
	 */
	public static class ModelGolem extends ModelBase {
		public ModelRenderer field_78176_b0;
		public ModelRenderer field_78176_b1;
		public ModelRenderer field_78174_d;
		public ModelRenderer field_78177_c;
		public ModelRenderer field_78175_e;
		public ModelRenderer field_78178_a0;
		public ModelRenderer field_78178_a1;
		public ModelRenderer field_78173_f;

		public ModelGolem() {
			this.textureWidth = 128;
			this.textureHeight = 128;
			this.field_78173_f = new ModelRenderer(this, 60, 0);
			this.field_78173_f.mirror = true;
			this.field_78173_f.setRotationPoint(5.0F, 11.0F, 0.0F);
			this.field_78173_f.addBox(-3.5F, -3.0F, -3.0F, 6, 16, 5, 0.0F);
			this.field_78177_c = new ModelRenderer(this, 60, 21);
			this.field_78177_c.setRotationPoint(0.0F, -7.0F, 0.0F);
			this.field_78177_c.addBox(-13.0F, -2.5F, -3.0F, 4, 30, 6, 0.0F);
			this.field_78175_e = new ModelRenderer(this, 37, 0);
			this.field_78175_e.setRotationPoint(-4.0F, 11.0F, 0.0F);
			this.field_78175_e.addBox(-3.5F, -3.0F, -3.0F, 6, 16, 5, 0.0F);
			this.field_78174_d = new ModelRenderer(this, 60, 58);
			this.field_78174_d.setRotationPoint(0.0F, -7.0F, 0.0F);
			this.field_78174_d.addBox(9.0F, -2.5F, -3.0F, 4, 30, 6, 0.0F);
			this.field_78178_a1 = new ModelRenderer(this, 24, 0);
			this.field_78178_a1.setRotationPoint(0.0F, -7.0F, -2.0F);
			this.field_78178_a1.addBox(-1.0F, -5.0F, -7.5F, 2, 4, 2, 0.0F);
			this.field_78176_b0 = new ModelRenderer(this, 0, 40);
			this.field_78176_b0.setRotationPoint(0.0F, -7.0F, 0.0F);
			this.field_78176_b0.addBox(-9.0F, -2.0F, -6.0F, 18, 12, 11, 0.0F);
			this.field_78176_b1 = new ModelRenderer(this, 0, 70);
			this.field_78176_b1.setRotationPoint(0.0F, -7.0F, 0.0F);
			this.field_78176_b1.addBox(-4.5F, 10.0F, -3.0F, 9, 5, 6, 0.5F);
			this.field_78178_a0 = new ModelRenderer(this, 0, 0);
			this.field_78178_a0.setRotationPoint(0.0F, -7.0F, -2.0F);
			this.field_78178_a0.addBox(-4.0F, -12.0F, -5.5F, 8, 10, 8, 0.0F);
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			this.field_78173_f.render(f5);
			this.field_78177_c.render(f5);
			this.field_78175_e.render(f5);
			this.field_78174_d.render(f5);
			this.field_78178_a1.render(f5);
			this.field_78176_b0.render(f5);
			this.field_78176_b1.render(f5);
			this.field_78178_a0.render(f5);
		}

		/**
		 * This is a helper function from Tabula to set the rotation of model
		 * parts
		 */
		public void setRotateAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(float f, float f1, float f2, float f3, float f4, float f5, Entity e) {
			super.setRotationAngles(f, f1, f2, f3, f4, f5, e);
			this.field_78178_a0.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.field_78178_a0.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.field_78178_a1.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.field_78178_a1.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.field_78174_d.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.field_78177_c.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.field_78175_e.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.field_78173_f.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}
}
