package net.mcreator.nightmarish_kingdom;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.init.Items;
import net.minecraft.entity.monster.EntitySkeleton;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIRestrictSun;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.model.ModelZombieVillager;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.model.ModelBase;

@Elementsnightmarish_kingdom.ModElement.Tag
public class MCreatorZombieArcher extends Elementsnightmarish_kingdom.ModElement {
	public static final int ENTITYID = 12;
	public static final int ENTITYID_RANGED = 13;

	public MCreatorZombieArcher(Elementsnightmarish_kingdom instance) {
		super(instance, 190);
	}

	@Override
	public void initElements() {
		elements.entities.add(() -> EntityEntryBuilder.create().entity(EntityCustom.class)
				.id(new ResourceLocation("nightmarish_kingdom", "zombie_archer"), ENTITYID).name("zombie_archer").tracker(64, 1, true)
				.egg(-452569088, -16372474).build());
	}

	@Override
	public void init(FMLInitializationEvent event) {
		Biome[] spawnBiomes = {Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:nightmarishkingdombiome")),
				Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:mesadesert")),
				Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:moutains")),
				Biome.REGISTRY.getObject(new ResourceLocation("nightmarish_kingdom:destroyedkingdombiome")),};
		EntityRegistry.addSpawn(EntityCustom.class, 100, 1, 2, EnumCreatureType.MONSTER, spawnBiomes);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void preInit(FMLPreInitializationEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(EntityCustom.class, renderManager -> {
			return new RenderLiving(renderManager, new ModelZombieVillager(), 0.5f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("nightmarish_kingdom:textures/zombie_archer.png");
				}
			};
		});
	}

	public static class EntityCustom extends EntitySkeleton {
		public EntityCustom(World world) {
			super(world);
			setSize(0.6f, 1.95f);
			experienceValue = 5;
			this.isImmuneToFire = false;
			setNoAI(!true);
			this.tasks.addTask(1, new EntityAIWander(this, 1));
			this.tasks.addTask(2, new EntityAILookIdle(this));
			this.tasks.addTask(3, new EntityAISwimming(this));
			this.tasks.addTask(4, new EntityAILeapAtTarget(this, (float) 0.8));
			this.tasks.addTask(5, new EntityAIRestrictSun(this));
			this.setItemStackToSlot(EntityEquipmentSlot.MAINHAND, new ItemStack(Items.BOW, (int) (1)));
		}

		@Override
		public EnumCreatureAttribute getCreatureAttribute() {
			return EnumCreatureAttribute.UNDEAD;
		}

		@Override
		protected Item getDropItem() {
			return new ItemStack(Items.ROTTEN_FLESH, (int) (1)).getItem();
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"entity.zombie_villager.ambient"));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"entity.zombie_villager.hurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"entity.zombie_villager.death"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source == DamageSource.FALL)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			if (this.getEntityAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(2D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.3D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(20D);
			if (this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(3D);
		}

		protected void dropRareDrop(int par1) {
			this.dropItem(new ItemStack(Items.ARROW, (int) (1)).getItem(), 1);
		}
	}

	/**
	 * ModelZombieVillager - Either Mojang or a mod author Created using Tabula
	 * 7.0.0
	 */
	public static class ModelZombieVillager extends ModelBase {
		public ModelRenderer field_178723_h;
		public ModelRenderer field_178721_j;
		public ModelRenderer field_78116_c0;
		public ModelRenderer field_78116_c1;
		public ModelRenderer field_78115_e0;
		public ModelRenderer field_78115_e1;
		public ModelRenderer field_178724_i;
		public ModelRenderer field_178722_k;
		public ModelRenderer field_178720_f;

		public ModelZombieVillager() {
			this.textureWidth = 64;
			this.textureHeight = 64;
			this.field_178722_k = new ModelRenderer(this, 0, 22);
			this.field_178722_k.mirror = true;
			this.field_178722_k.setRotationPoint(2.0F, 12.0F, 0.10000000149011612F);
			this.field_178722_k.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F);
			this.field_178720_f = new ModelRenderer(this, 32, 0);
			this.field_178720_f.setRotationPoint(0.0F, 0.0F, 0.0F);
			this.field_178720_f.addBox(-4.0F, -8.0F, -4.0F, 8, 8, 8, 0.5F);
			this.field_78116_c1 = new ModelRenderer(this, 24, 0);
			this.field_78116_c1.setRotationPoint(0.0F, 0.0F, 0.0F);
			this.field_78116_c1.addBox(-1.0F, -3.0F, -6.0F, 2, 4, 2, 0.0F);
			this.field_178723_h = new ModelRenderer(this, 44, 38);
			this.field_178723_h.setRotationPoint(-5.0F, 2.0F, 0.0F);
			this.field_178723_h.addBox(-3.0F, -2.0F, -2.0F, 4, 12, 4, 0.0F);
			this.setRotateAngle(field_178723_h, -1.3962634801864624F, -0.10000000149011613F, 0.10000000149011613F);
			this.field_178724_i = new ModelRenderer(this, 44, 38);
			this.field_178724_i.mirror = true;
			this.field_178724_i.setRotationPoint(5.0F, 2.0F, 0.0F);
			this.field_178724_i.addBox(-1.0F, -2.0F, -2.0F, 4, 12, 4, 0.0F);
			this.setRotateAngle(field_178724_i, -1.3962634801864624F, 0.10000000149011613F, -0.10000000149011613F);
			this.field_178721_j = new ModelRenderer(this, 0, 22);
			this.field_178721_j.setRotationPoint(-2.0F, 12.0F, 0.10000000149011612F);
			this.field_178721_j.addBox(-2.0F, 0.0F, -2.0F, 4, 12, 4, 0.0F);
			this.field_78116_c0 = new ModelRenderer(this, 0, 0);
			this.field_78116_c0.setRotationPoint(0.0F, 0.0F, 0.0F);
			this.field_78116_c0.addBox(-4.0F, -10.0F, -4.0F, 8, 10, 8, 0.0F);
			this.field_78115_e0 = new ModelRenderer(this, 16, 20);
			this.field_78115_e0.setRotationPoint(0.0F, 0.0F, 0.0F);
			this.field_78115_e0.addBox(-4.0F, 0.0F, -3.0F, 8, 12, 6, 0.0F);
			this.field_78115_e1 = new ModelRenderer(this, 0, 38);
			this.field_78115_e1.setRotationPoint(0.0F, 0.0F, 0.0F);
			this.field_78115_e1.addBox(-4.0F, 0.0F, -3.0F, 8, 18, 6, 0.04999961890280247F);
		}

		@Override
		public void render(Entity entity, float f, float f1, float f2, float f3, float f4, float f5) {
			this.field_178722_k.render(f5);
			this.field_178720_f.render(f5);
			this.field_78116_c1.render(f5);
			this.field_178723_h.render(f5);
			this.field_178724_i.render(f5);
			this.field_178721_j.render(f5);
			this.field_78116_c0.render(f5);
			this.field_78115_e0.render(f5);
			this.field_78115_e1.render(f5);
		}

		/**
		 * This is a helper function from Tabula to set the rotation of model
		 * parts
		 */
		public void setRotateAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(float f, float f1, float f2, float f3, float f4, float f5, Entity e) {
			super.setRotationAngles(f, f1, f2, f3, f4, f5, e);
			this.field_178721_j.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.field_178722_k.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
		}
	}
}
